#define UNDERLIERS_SIZE 20                               /* Maximum number of underliers */
#define TIMESLICES_SIZE 13                               /* Maximum number of timeslices: 0 - TIMESLICES-1 */
#define POINTS_SIZE 20000                                /* Maximum number of points on last timeslice */
#define DEBUG 0                                          /* Debugging output? */
#define PHRASE "I Love Money"                            /* Phrase hashed into seed1 and seed2 */
#define SEED1 seed1                                      /* First RNG seed. Use seed1 to get value from phrase */
#define SEED2 time(NULL)                                 /* Second RNG seed. Use seed2 to get value from phrase */

extern int  Max1[TIMESLICES_SIZE][POINTS_SIZE],          /* Largest underlier price */
  Number_with_max[TIMESLICES_SIZE][UNDERLIERS_SIZE],
  Max2[TIMESLICES_SIZE][POINTS_SIZE];                    /* Second largest underlier price */

extern double
  Price[TIMESLICES_SIZE][UNDERLIERS_SIZE][POINTS_SIZE],  /* Prices of underliers */
  Prob[TIMESLICES_SIZE][UNDERLIERS_SIZE][POINTS_SIZE],   /* Probability of underlier becoming max */
  Value_if_exercised[TIMESLICES_SIZE][POINTS_SIZE],      /* Value of option if exercised at [t][p] */
  Value[TIMESLICES_SIZE][POINTS_SIZE],                   /* Value of option at [t][p] */
  Weight[POINTS_SIZE],
  Cov[UNDERLIERS_SIZE*UNDERLIERS_SIZE],
  Parm[UNDERLIERS_SIZE*(UNDERLIERS_SIZE+3)/2+1],
  Scratch[UNDERLIERS_SIZE],
  Underlier_mask[UNDERLIERS_SIZE],
  Sum_weights,
  Ignore[TIMESLICES_SIZE],
  Ignore_den[TIMESLICES_SIZE];
  
extern double mask[POINTS_SIZE],S8U[UNDERLIERS_SIZE],S7U[UNDERLIERS_SIZE],
              g[POINTS_SIZE];     

/* These now come from the command line */
extern int TIMESLICES, POINTS, UNDERLIERS, REPETITIONS,MINPOINTS,MAXIGNORE;
extern double POWER,PROBCUTOFF,EXPIRATION,INTEREST,DIVIDEND,VARIANCE,STRIKE,INITIAL;

int generate_mask(int t1, int p1);
static void weights1(int t1, int p1, int t2);
void weights2(int t1, int p1, int t2);
void init_rng(int t);
int points_on_timeslice(int t);
void generate_point(int t, int p);
void prob_of_max(int t, int p);
double mesh_estimate_0(int t, int p);
double mesh_estimate_3(int t, int p);
